routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('backoffice.home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::middleware('auth')->group(function () {
    Route::resource('products','ProductsController')->except([
        "show"
    ]);
    Route::resource('categories','CategoriesController')->except([
        "show"
    ]);
    /*
		Commands Controller
    */
	Route::get('commands','CommandsController@index')->name('commands.list');
	Route::get('commands/{command}','CommandsController@consulte')->name('commands.consulte');
	Route::delete('commands/delete/{command}','CommandsController@remove')->name('commands.remove');
});

app/Category.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    protected $guarded = [];

    public function products () {
        return $this->hasMany(Product::class);
    }
}

app/Http/Controllers/API/CategoriesController.php
<?php

namespace App\Http\Controllers\API;

use App\Category;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class CategoriesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index ()
    {
        return response()->json([
            "success" => true,
            "categories" => Category::all()
        ]);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function show (Category $category)
    {
        return response()->json([
            "success" => true,
            "category" => $category,
            "products" => $category->products()->paginate(3)
        ]);
    }
}

app/Http/Controllers/CategoriesController.php
<?php

namespace App\Http\Controllers;

use App\Category;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class CategoriesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view("backoffice.categories.index",[
            "categories" => Category::all()
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backoffice.categories.form',[
            "category" => new Category
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request,[
            "title" => "required"
        ]);
        $fill = $request->only('title');
        if ($request->has('description')) {
            $fill['description'] = $request->description;
        }
        if ($request->has('cover')) {
            $filename = Str::slug($request->title).".".$request->cover->getClientOriginalExtension();
            $fill['cover'] = asset('storage/uploads/'.$filename);
            $request->cover->storeAs('uploads',$filename,'public');
        }
        Category::create($fill);
        return redirect()->route('categories.index')->with("alert",[
            "type" => "success",
            "message" => "Category has been added"
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function edit(Category $category)
    {
        return view('backoffice.categories.form',[
            "category" => $category
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Category $category)
    {
        $this->validate($request,[
            "title" => "required"
        ]);
        $fill = $request->only('title','description');
        if ($request->has('cover')) {
            $old_image = last(explode('/', $category->cover));
            @unlink(storage_path('app/public/uploads/'.$old_image));
            $filename = Str::slug($request->title).".".$request->cover->getClientOriginalExtension();
            $fill['cover'] = asset('storage/uploads/'.$filename);
            $request->cover->storeAs('uploads',$filename,'public');
        }
        $category->update($fill);
        return redirect()->route('categories.index')->with("alert",[
            "type" => "success",
            "message" => "Category has been updated"
        ]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {
        if ($category->products->count() > 0) {
            return redirect()->back()->with("alert",[
                "type" => "danger",
                "message" => "Category can not be deleted because it have products on it"
            ]);
        }
        $category->delete();
        return redirect()->route('categories.index')->with("alert",[
            "type" => "info",
            "message" => "Category has been deleted"
        ]);
    }
}

resources/views/backoffice/categories/form.blade.php
@extends('layouts.backoffice')

@section('content')
  <!-- .row -->
  <div class="row">
      <div class="col-lg-12">
          <div class="card">
            <div class="card-body">
                <h5 class="card-title block">{{ (is_null($category->id)) ? 'Add Category' : 'Edit: '.$category->title }} </h5>
                <br>
                @if(session('alert'))
                    <div class="my-4">
                        <div class="alert alert-{{ session('alert')['type'] }}">
                            {{ session('alert')['message'] }}
                        </div>
                    </div>
                @endif
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                @endif
                <div class="my-4">
                    <form method="post" action="{{ (is_null($category->id)) ? route('categories.store') : route('categories.update',$category->id) }}" enctype="multipart/form-data">
                        @csrf
                        @if(!is_null($category->id))
                            @method('PUT')
                        @endif
                        <div class="form-group">
                            <label for="title">Title</label>
                            <input type="text" class="form-control" name="title" id="title" placeholder="Category title" value="{{ old('title',$category->title) }}">
                        </div>
                        <div class="form-group">
                            <label for="description">Description</label>
                            <textarea class="form-control" name="description" id="description" placeholder="Category description">{{ old('description',$category->description) }}</textarea>
                        </div>
                        <div class="form-group">
                            <label for="cover">Cover image</label>
                            <input min="0" type="file" class="form-control-file" name="cover" id="cover">
                        </div>
                        <button type="submit" class="btn btn-success">{{ (is_null($category->id)) ? 'Save' : 'Update'}}</button>
                    </form>
                </div>
            </div>
          </div>
      </div>
  </div>
  <!-- /.row -->
@endsection

resources/views/backoffice/categories/index.blade.php
@extends('layouts.backoffice')

@section('content')
  <!-- .row -->
  <div class="row">
      <div class="col-lg-12">
          <div class="card">
            <div class="card-body">
                <h5 class="card-title">Categories</h5>
                @if(session('alert'))
                    <div class="my-4">
                        <div class="alert alert-{{ session('alert')['type'] }}">
                            {{ session('alert')['message'] }}
                        </div>
                    </div>
                @endif
                @if($categories->count() > 0)
                <table class="table table-bordered">
                    <thead>
                        <tr>
                            <th>Id</th>
                            <th>Title</th>
                            <th>Products</th>
                            <th>Created at</th>
                            <th>Last update</th>
                            <th width="200px">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($categories as $category)
                            <tr>
                                <td>{{ $category->id }}</td>
                                <td>{{ $category->title }}</td>
                                <td>{{ $category->products->count() }}</td>
                                <td>{{ $category->created_at->format('d/m/Y H:i:s') }}</td>
                                <td>{{ $category->updated_at->format('d/m/Y H:i:s') }}</td>
                                <td>
                                    <a href="{{ route('categories.edit',$category->id)}}" class="btn btn-sm btn-warning">edit</a>
                                    <form method="post" action="{{ route('categories.destroy',$category->id) }}">
                                        @method('DELETE')
                                        @csrf
                                        <button class="btn btn-sm btn-danger">delete</button>
                                    </form>
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
                @else
                    <div class="alert alert-info">
                        <h4>You have no categories to display please <a href="{{ route('categories.create') }}">create one</a> to get started</h4>
                    </div>
                @endif
            </div>
          </div>
      </div>
  </div>
  <!-- /.row -->
@endsection